Attribute VB_Name = "excel_mod"

'EXCEL CLASS DEMONSTRATION.
'Philip Bolt, January, 2006

'For the purpose of this demo only one work book can be opened at a time.
'In general, as many workbooks as required can be open but there can only be
'one instance of ExcelApplication.

Public path As String

Public canceled As Boolean
Public book_loaded As Boolean

'WORKBOOK OBJECTS
Public wbk As Object                    'Excel Workbook object
Public cur_sht As Object                'Current workbook sheet object.
Public wk_sht As Object                 'A worksheet object.
Public rnge As Object                   'Worksheet range.

Public cdc As Object                    'CDC object.

'CLASS OBJECTS
Public xlApp As New ExcelApplication    'ExcelApplication object
Public xlBook As New ExcelWorkbook      'ExcelWorkbook object.

Sub set_up()

    path = App.path + "\"
    
    Set cdc = excel_main.cdc1   'Define the CDC
    
End Sub

'Routine to open a workbook.
'Procedure name:    open_workbook

Sub open_workbook()

    close_workbook      'Close any open workbook.

    full_file_path = choose_file    'Select the data file.
     
    If canceled Then                'If the user CANCELs the file selection,
        Exit Sub
    End If
    
    Set xlBook = xlApp.Add(full_file_path)  'Open the book by adding an item to the
                                            'ExcelApplication' workbook collection.
    If Not canceled Then
        Set wbk = xlBook.get_book   'Store the workbook object and
        book_loaded = True          'flag that a workbook is loaded.
    Else                            'Otherwise,
        close_down                  'close down if there's an error.
    End If
 
    wbk.Application.WindowState = xlMaximized   'Adjust the window and
    excel_main.SetFocus                         'display the form over the book.
    
    excel_main.Label1.Caption = "Book name is " + xlBook.name
    excel_main.Label2.Caption = "Current sheet is " + xlBook.sheet_name
     
End Sub

'Routine to select and get the name of an '.XLS' file.
'Function name: choose_file()

 Function choose_file()

    cdc.DialogTitle = "SELECT AN EXCEL WORKBOOK"
    cdc.InitDir = path
    cdc.Flags = cdlOFNNoChangeDir Or cdlOFNPathMustExist  'Set up the flags
    cdc.Filter = "Excel files(*.XLS)|*.XLS|"
    
    vlid = False
    
    Do Until vlid   'Loop until a valid name is entered or the user CANCELs.
        On Error GoTo userCancel
            cdc.ShowOpen     'Display the 'Open' window.
        On Error GoTo 0
        fn = cdc.FileName
 
        vlid = True
    Loop
    
    choose_file = fn
    
Exit Function

userCancel:

    canceled = True     'Flag that the user CANCELed and return
    choose_file = ""    'an empty string.
    
End Function

'Routine to close a workbook.

Sub close_workbook()

    If book_loaded Then                 'Shut down any open book.
        b_nme = xlBook.name             'Store the current book name,
        xlApp.Delete b_nme              'delete it from the collection and
        Set xlBook = Nothing            'release its handle.
        
        excel_main.Label1.Caption = ""  'Clear the data display.
        excel_main.Label2.Caption = ""
        
        book_loaded = False             'Clear the book loaded flag.
    End If

End Sub

'Routine to process the 'SheetActivate' event which occurs when a new sheet is selected.
'Procedure name:    select_sheet_action(s_name, b_name)
'Parameters:        s_name; new sheet name,
'                   b_name; book name.

Sub select_sheet_action(s_name, b_name)

    excel_main.Label2.Caption = "Current sheet is " + s_name    'Change to the new sheet and
    excel_main.SetFocus                                         'return form to front.

End Sub

'Routine to close down Excel.

Sub close_down()

    Set cur_sht = Nothing   'Release the handles in increasing order
    Set wbk = Nothing       'of complexity.
    Set xlBook = Nothing    'i.e. Sheet, Workbook,
    Set xlApp = Nothing     'ExcelWorkbook, ExcelApplication.

End Sub
